// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_29_simple_string_serializer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    deseialize_person_: TButton;
    serialize_button_: TButton;
    deserialize_button_: TButton;
    create_and_serialze_person_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure deserialize_person_Click(Sender: TObject);
    procedure serialize_button_Click(Sender: TObject);
    procedure deserialize_button_Click(Sender: TObject);
    procedure create_and_serialze_person_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses Rtti, System.TypInfo
        , u_display_simple, u_c_person_properties_2
        , u_c_string_serializer;

    {$R *.dfm}

    var g_serialized_person: String= '';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- person

    procedure TForm1.create_and_serialze_person_Click(Sender: TObject);
      var l_c_person: c_person;
          l_c_serializer: c_serializer;
      begin
        l_c_person:= c_person.create_person('matt', 45, 5461.33);
        display(l_c_person.f_display_person);

        l_c_serializer:= c_serializer.Create;
        g_serialized_person:= l_c_serializer.f_serialize(l_c_person);
        l_c_serializer.free;
        l_c_person.Free;

        display(g_serialized_person)
      end; // create_and_serialze_person_Click

    procedure TForm1.deserialize_person_Click(Sender: TObject);
      var l_c_person: c_person;
          l_c_deserializer: c_deserializer;
      begin
        l_c_person:= c_person.create_person('smith', 33, 4567.00);
        l_c_person:= c_person.create_person('', 0, 0);
        l_c_deserializer:= c_deserializer.Create;
        l_c_deserializer.deserialize(g_serialized_person, l_c_person);
        display(l_c_person.f_display_person);
      end; // deserialize_person_

    // -- example with a tButton

    var g_c_button_text: tStringList;

    procedure TForm1.serialize_button_Click(Sender: TObject);
      var l_c_serializer: c_serializer;
      begin
        l_c_serializer:= c_serializer.Create;
        g_c_button_text:= tStringList.Create;

        g_c_button_text.Text:= l_c_serializer.f_serialize(Sender);

        display(g_c_button_text.Text);
      end; // serialize_button_Click

    procedure TForm1.deserialize_button_Click(Sender: TObject);
        // -- change the Left, Caption in the tStringList, unserialise into Sender
        // -- => changes this buttons position and caption
      var l_c_deserializer: c_deserializer;
      begin

        with g_c_button_text do
        begin
          Values['Left']:= '50';
          // Values['Top']:= IntToStr(serialize_button_.Top)
        end;

        l_c_deserializer:= c_deserializer.Create;
        l_c_deserializer.deserialize(g_c_button_text.Text, serialize_button_);
      end; // deserialize_button_Click


end.
